<template>
  <div id="page--login">
    <div class="login-container">
      <div class="login-background">
        <div class="login-card">
          <b-card no-body class="overflow-hidden">
            <b-row no-gutters>
              <b-col md="6" class="d-flex justify-content-center align-items-center">
                <img src="~/assets/images/login-image.jpg" alt="Logo" class="rounded-0 w-100" />
              </b-col>
              <b-col md="6" class="d-flex flex-column justify-content-center align-items-center">
                <img src="~/assets/images/logo.png" />
                <b-card-body title="THE SOLUTION SYSTEM - DSVN">
                  <div class="login-form">
                    <validation-observer v-slot="{ invalid }">
                      <b-form @submit.prevent="login">
                        <validation-provider name="email" rules="required|email" v-slot="{ errors }">
                          <b-form-group label="Email" label-for="email">
                            <b-form-input
                              id="email"
                              type="email"
                              v-model="credential.email"
                              placeholder="Enter your email"
                            ></b-form-input>
                          </b-form-group>
                          <span class="text-danger text-sm">{{ errors[0] }}</span>
                        </validation-provider>
                        <validation-provider
                          name="password"
                          rules="required"
                          v-slot="{ errors }"
                        >
                        <b-form-group label="Password" label-for="password">
                          <b-input
                            type="password"
                            id="text-password"
                            v-model="credential.password"
                            aria-describedby="password-help-block"
                          ></b-input>
                          <b-form-text id="password-help-block">
                            Your password must be 8-20 characters long, contain letters and
                            numbers, and must not
                            contain spaces, special characters, or emoji.
                          </b-form-text>
                          <span class="text-danger text-sm">{{ errors[0] }}</span>
                        </b-form-group>
                        </validation-provider>
                        <b-button type="submit" :disabled="invalid" variant="danger">Login</b-button>
                      </b-form>
                    </validation-observer>
                  </div>
                </b-card-body>
              </b-col>
            </b-row>
          </b-card>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import AuthService from '@/services/auth.service.js'

import { ValidationProvider, ValidationObserver, extend } from "vee-validate"
import { required, email } from "vee-validate/dist/rules"
// Add the required rule
extend("required", {
  ...required,
  message: "Field {_field_} is required"
})

extend("email", {
  ...email,
  message: "Enter a valid email address to use as your account ID"
})

export default {
  name: 'AuthLogin',
  layout: 'full',
  data() {
    return {
      credential: {
        email: 'nam-le@dimage.co.jp',
        password: '123456789'
      }
    }
  },
  components: {
    "validation-provider": ValidationProvider,
    "validation-observer": ValidationObserver
  },
  computed: {
    authService() {
      return new AuthService(this.$api)
    }
  },
  methods: {
    login() {
      this.authService.login(this.credential).then(response => {
        if (response) {
          this.$router.push({name: 'index'}).catch(() => {})
        }
      }).catch(ex => {
        this.$notify.error(this.$bvToast, ex.message)
      })
    }
  },
  mounted() {
    console.log(this.$route)
  }
};
</script>
